﻿// -----------------------------------------------------------------------
// <copyright file="ViewModel.cs" company="Microsoft">
// TODO: Update copyright text.
// </copyright>
// -----------------------------------------------------------------------

namespace SilverlightApplication8
{
	using System;
	using System.Collections.Generic;
	using System.Linq;
	using System.Text;
	using System.Collections.ObjectModel;
	using Telerik.Windows.Controls.GanttView;
	using Telerik.Windows.Controls.Scheduling;
	using Telerik.Windows.Core;

	public class ViewModel : PropertyChangedBase
	{
		public ViewModel()
		{
			var date = DateTime.Now;

			var iterationTask = new GanttTask() { Start = date, End = date.AddDays(2), Title = "First Iteration" };
			var nextIterationTask = new GanttTask() { Start = date.AddDays(7), End = date.AddDays(9), Title = "Second Iteration" };
			var ganttAPI = new GanttTask() { Start = date, End = date.AddHours(16), Title = "Design public API" };

			var ganttDemos = new GanttTask() { Start = date.AddHours(18), End = date.AddDays(1), Title = "Gantt Demos" };
			var ganttRendering = new GanttTask() { Start = date.AddDays(1).AddHours(5), End = date.AddDays(2), Title = "Gantt Rendering" };

			var milestone = new GanttTask() { Start = date.AddDays(2), End = date.AddDays(2).AddHours(1), Title = "Review", IsMilestone = true };
			ganttAPI.SetRelations(new List<Relation>() { new Relation() { Task = ganttDemos } });
			ganttDemos.SetRelations(new List<Relation>() { new Relation() { Task = ganttRendering } });

			iterationTask.SetChildren(new ObservableCollection<GanttTask>() { ganttAPI, ganttDemos, ganttRendering, milestone });
			var gTasks = new ObservableCollection<GanttTask>();
			gTasks.Add(iterationTask);
			gTasks.Add(nextIterationTask);
			this.Tasks = gTasks;
			this.VisibleRange = new VisibleRange(date, date.AddDays(9));
		}
		private IEnumerable<GanttTask> tasks;

		public IEnumerable<GanttTask> Tasks
		{
			get
			{
				return tasks;

			}
			set
			{
				tasks = value;
				OnPropertyChanged(() => Tasks);
			}

		}

		private VisibleRange visibleRange;
		public VisibleRange VisibleRange
		{
			get
			{
				return visibleRange;
			}
			set
			{
				if (visibleRange != value)
				{
					visibleRange = value;
					OnPropertyChanged(() => VisibleRange);
				}
			}
		}

		
	}
}
